<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->
<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml"
                template="//layout/template.xhtml">
    <ui:param name="pageName" value="#{messages['gazelle.evs.client.hl7.validator.title']}"/>
    <ui:param name="pageNameUrl" value="hl7v2/validator.seam"/>
    <ui:param name="pageNameTitle" value="#{messages['gazelle.evs.client.hl7.validator.title']}"/>
    <ui:define name="header">
        <link href="/xsl/EVSClient/resultStyle.css" rel="stylesheet" type="text/css" media="screen"/>
        <link href="/xsl/EVSClient/common/filteredreport.css" rel="stylesheet" type="text/css" media="screen"/>
        <script type="text/javascript" src="/xsl/EVSClient/common/commonfilteredreport.js"/>
        <script type="text/javascript" src="/xsl/EVSClient/hl7v2/hl7filteredreport.js"/>
        <h:outputStylesheet library="stylesheet" name="extraxml.css"/>
    </ui:define>
    <ui:define name="body">

        #{hl7Validator.init()}

        <s:div id="globalDiv">
            <h:form id="globalForm">
                <s:div id="inputDiv" rendered="#{!hl7Validator.isValidationDone()}">
                    <s:token id="hl7v2Token" allowMultiplePosts="true"/>

                    <s:decorate template="/common/fileUploaderOrPasteContent.xhtml">
                        <ui:param name="managedBean" value="#{hl7Validator}"/>
                        <ui:param name="pasteContentAccepted" value="true"/>
                        <ui:define name="specificButtons">
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.evs.GuessMessageProfile']}"
                                               actionListener="#{managedBean.guessProfile(true)}"
                                               rendered="#{managedBean.filterMode == hl7Validator.ALL}"
                                               styleClass="gzl-btn-blue" render="globalForm" execute="hl7v2Token"/>
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.evs.ShowAllMessageProfiles']}"
                                               actionListener="#{managedBean.guessProfile(false)}"
                                               rendered="#{managedBean.filterMode == hl7Validator.GUESS}"
                                               styleClass="gzl-btn-blue" render="globalForm" execute="hl7v2Token"/>
                        </ui:define>
                        <ui:define name="specificMessage">
                            <h:outputText value="#{messages['gazelle.evs.client.hl7.select.message']}" rendered="#{managedBean.document == null}"/>
                        </ui:define>
                    </s:decorate>

                    <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">

                        <ui:param name="panel_id" value="validatorPanel2"/>
                        <ui:define name="panel_title">
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.evs.HL7MessageProfileSelection']}"/>
                        </ui:define>
                        <h:outputText
                                value="#{messages['net.ihe.gazelle.evs.InTheTableBelowSelectTheHL7MessageProfileWhichMa']}"/>
                        <s:div rendered="#{hl7Validator.getStandardDescription() != null}">
                            <s:span styleClass="help-block">
                                <g:safehtml value="#{hl7Validator.getStandardDescription()}"/>
                            </s:span>
                        </s:div>
                        <ui:define name="panel_footer">
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.evs.GuessMessageProfile']}"
                                               actionListener="#{hl7Validator.guessProfile(true)}"
                                               rendered="#{hl7Validator.filterMode == hl7Validator.ALL}"
                                               styleClass="gzl-btn-blue" render="globalForm" execute="hl7v2Token"/>
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.evs.ShowAllMessageProfiles']}"
                                               actionListener="#{hl7Validator.guessProfile(false)}"
                                               rendered="#{hl7Validator.filterMode == hl7Validator.GUESS}"
                                               styleClass="gzl-btn-blue" render="globalForm" execute="hl7v2Token"/>
                        </ui:define>

                        <s:div id="messageProfiles">
                            <rich:dataTable value="#{hl7Validator.messageProfiles}" var="profile"
                                            rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                            id="messageProfilesTable" render="ds"
                                            styleClass="table table-striped table-responsive">
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['gazelle.evs.client.hl7.affinityDomain']}"
                                                      style="font-weight:bold;"/>

                                        <ui:include src="/hl7v2/customFilter.xhtml">
                                            <ui:param name="filter" value="#{hl7Validator.filter}"/>
                                            <ui:param name="filterId" value="affinityDomain"/>
                                            <ui:param name="filterForm" value="globalForm"/>
                                        </ui:include>
                                    </ui:define>
                                    <rich:list value="#{profile.affinityDomains}" var="ad" type="unordered">
                                        #{ad.labelToDisplay}
                                    </rich:list>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['gazelle.evs.client.hl7.domain']}"
                                                      style="font-weight:bold;"/>

                                        <ui:include src="/hl7v2/customFilter.xhtml">
                                            <ui:param name="filter" value="#{hl7Validator.filter}"/>
                                            <ui:param name="filterId" value="domain"/>
                                            <ui:param name="filterForm" value="globalForm"/>
                                        </ui:include>
                                    </ui:define>
                                    #{profile.domain.name}
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['gazelle.evs.client.hl7.actor']}"
                                                      style="font-weight:bold;"/>

                                        <ui:include src="/hl7v2/customFilter.xhtml">
                                            <ui:param name="filter" value="#{hl7Validator.filter}"/>
                                            <ui:param name="filterId" value="actor"/>
                                            <ui:param name="filterForm" value="globalForm"/>
                                        </ui:include>
                                    </ui:define>
                                    #{profile.actor.name}
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['gazelle.evs.client.hl7.transaction']}"
                                                      style="font-weight:bold;"/>

                                        <ui:include src="/hl7v2/customFilter.xhtml">
                                            <ui:param name="filter" value="#{hl7Validator.filter}"/>
                                            <ui:param name="filterId" value="transaction"/>
                                            <ui:param name="filterForm" value="globalForm"/>
                                        </ui:include>
                                    </ui:define>
                                    #{profile.transaction.keyword}
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['net.ihe.gazelle.evs.MessageType']}"
                                                      style="font-weight:bold;"/>

                                        <ui:include src="/hl7v2/customFilter.xhtml">
                                            <ui:param name="filter" value="#{hl7Validator.filter}"/>
                                            <ui:param name="filterId" value="messageType"/>
                                            <ui:param name="filterForm" value="globalForm"/>
                                        </ui:include>
                                    </ui:define>
                                    <h:outputText value="#{profile.messageType}"/>
                                    <h:outputText value=" (#{profile.messageOrderControlCode})"
                                                  rendered="#{not empty profile.messageOrderControlCode}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['gazelle.evs.client.hl7.version']}"
                                                      style="font-weight:bold;"/>

                                        <ui:include src="/hl7v2/customFilter.xhtml">
                                            <ui:param name="filter" value="#{hl7Validator.filter}"/>
                                            <ui:param name="filterId" value="hl7Version"/>
                                            <ui:param name="filterForm" value="globalForm"/>
                                        </ui:include>
                                    </ui:define>
                                    #{profile.hl7Version}
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['gazelle.evs.client.hl7.profileOID']}"
                                                      style="font-weight:bold;"/>
                                    </ui:define>
                                    <a href="#{hl7Validator.profileLink(profile)}"
                                       target="_blank">#{profile.profileOid}</a>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:outputText value="#{messages['gazelle.common.Action']}"/>
                                    </ui:define>
                                    <a4j:commandLink title="#{messages['net.ihe.gazelle.Select']}"
                                                     actionListener="#{hl7Validator.validateMessage(profile)}"
                                                     oncomplete="
                                                        if(#{hl7ResultDisplay.sendBackResultToTool()})
                                                            {jq162('#sendBackToCallingTool').modal('show')}
                                                        else if (#{hl7ResultDisplay.displayInfoPopup()})
                                                            {jq162('#infoPopup').modal('show')}
                                                        else
                                                            {jq162('#sendBackToCallingTool').modal('hide')}"
                                                     render="resultPanel,globalDiv,messageProfilesTable,ds"
                                                     execute="@globalForm">
                                        <!-- This actionListener is executed after the commandLink actionListener -->
                                        <!-- It was before in the onComplete but was not called if the datascroller page was more than 1 -->
                                        <f:actionListener binding="#{hl7ResultDisplay.init(hl7Validator.buildAndGetValidationResultDto(),hl7Validator.referencedStandard.id)}"/>
                                        <span class="fa fa-arrow-right"/>
                                    </a4j:commandLink>
                                    <h:commandLink
                                            title="#{messages['net.ihe.gazelle.evs.GetXMLWebserviceRequest']}"
                                            rendered="#{hl7Validator.uploadedFileContent != null}"
                                            action="#{hl7Validator.downloadWebServiceBody(profile)}">
                                        <span class="fa fa-code"/>
                                    </h:commandLink>
                                </g:column>
                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="ds"/>
                                        <ui:param name="dataTableId" value="messageProfilesTable"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>
                        </s:div>
                    </ui:decorate>
                </s:div>
                <s:div id="resultPanel">
                    <s:div id="validationResultPanel" rendered="#{hl7Validator.isValidationDone()}">
                        <ui:include src="/hl7v2/detailedResult.xhtml"/>
                    </s:div>
                </s:div>
            </h:form>

        </s:div>
    </ui:define>
</ui:composition>

